#!/usr/local/bin/perl  
#
####################################
# IMPROVED WWWBOARD
# 
# This script is an improved version of:
# WWWBoard by Matt Wright (see legal stuff below)
#
# Matt's Script is the web's standard WWWBoard script - used on tens of thousands
# of sites on the Net. It is simple, elegant, and intuitive. This script is an update
# of Matt's WWWBoard, with several major improvements:
#
# BUG FIXES:
# Matt's Script was full of bugs (it never went past Alpha 2)
# - *Many* Bugs Fixed. Now, hopefully, bug free!
# 
# SECURITY FIXES:
# Matt's Script paid little attention to security. This board is, basically, a 
# 'hackers' fix of the board. It is now immune from all known attacks.
# - All standard attacks plugged (about 5).
# - 6 hypothetical attacks plugged.
# - User Banning Mod Added (ban users IPs)
# - C.Y.R.Y.L Topic Banning Mod Added (ban words, phrases, concepts)
# - Anti-Spam Protection
# - Remote Post Protection Added
# - Board Bombing Fixed (Rootshell Sep'98 Attack)
# - No More Empty Names / Subjects
# - No More Huge Names / Subjects / Posts (size limits)
# - User Logging (Shows IP, ISP, Browser, etc.)
# - Webmaster's Posts Authentication
#
# LOOK / FEEL:
# - Change look of all pages / posts by setting one variable (header / footer).
#
# AUTO CUTTING:
# - Yes! Finally, set the board to the size you want and leave it!
#
# *** Questions / Bug Reports should go to www.cyberarmy.com/wwwboard
#
###########################################
# BORING LEGAL STUFF -
#
# This improvement was compiled by www.cyberarmy.com. As far as I'm concerned,
# this board is fully open source and free. Main contributors are first, Matt Wright,
# who did the base script. Matt's Script was extensively hacked by Ken Williams (packetstorm@genocide2600.com)
# then by Samuel Sparling (Epicurus). Then all the improvements, and other mods were
# added and polished by webmaster@cyberarmy.com. Improve it! Distribute it!
# You may not charge for it, or remove these comments. As requested, the original legal stuff by Matt Wright remains below:
#
# WWWBoard Version 2.0 ALPHA 2 Copyright 1996 Matt Wright mattw@worldwidemart.com Created 10/21/95 Last Modified 11/25/95 Scripts Archive at: http://www.worldwidemart.com/scripts/
# WWWBoard may be used and modified free of charge by anyone so long as this copyright notice and the comments above remain intact.  By using this code you agree to indemnify Matthew M. Wright and any other developers of the script from any liability that might arise from it's use. Selling the code
# for this program without prior written consent is expressly forbidden. In other words, please ask first before you try and make money off of my program. Obtain permission before redistributing this software over the Internet or in any other medium.  In all cases copyright and header must remain intact.
##############################################################################


##########################################
# VARIABLES - You must edit at least the
# 'File Locations' section to setup board.
#

    ########################
    # File Locations
    #

       $basedir = "/blah/home/yoursite/public_html/wwwboard";  # real path where your board dir is (your FTP client usually shows the real path)
       $baseurl = "http://www.yoursite.com/wwwboard";  # URL of your board dir
       $cgi_url = "http://www.yoursite.com/wwwboard/board.cgi"; # URL where this (yes! this very) cgi script is :)
       @referers = ('www.yoursite.com','yoursite.com'); # base domain name where your site is


       $datafile = "data.txt";          # You _can_ leave this all as is.
       $mesgfile = "index.html";       # It might be better security if you change them,
       $faqfile = "faq.html";          # but not really needed.
       $no_spam_file = "nospam.txt";    # NOTE: You _should_ change the name of the
       $ip_file = "banlist.txt";        # default password file in the admin.cgi script,
       $topicban_file = "topicban.txt"; # that's all!
       $mesgdir = "messages";           #
       $ext = "html";  # change to "shtml" if you want SSI. If you dont know what Im talking about, leave this as html



   ############################
   # Look / Feel Variables
   #
	
     $title = "Improved WWWBoard";     # Title of the board
     $page_top = "<BODY BGCOLOR=\"#000000\" TEXT=\"#00ff00\" LINK=\"#00ff00\" VLINK=\"#008080\" alink=\"#00FF00\"><font face=\"arial\"><br>\n"; # This html will go at the top of every page (all error pages, message posts, etc.) It is _not_ standard html. You must put a \ sign in front of " or @ symbols, and some others.
     $page_bottom = "<br><br><hr><a href=\"http://www.cyberarmy.com/files/board.zip\">Improved WWWBoard</a>.";    # This html will go at the bottom of every page (all error pages, message posts, etc.) It is _not_ standard html. You must put a \ sign in front of " or @ symbols, and some others.


   ###################################
   # Security Variables (1=ON, 0=OFF)
   # (leave all security on unless you know what you're doing).
   # 

      $user_ban =1;                    # activate IP banning (users listed in banlist.txt)
      $topic_ban = 1;                  # activate topic banning (words, phrases listed in topicban.txt)
      $environment_lock = 1;           # activate get_env protection (stop 90% of external form input)
      $bomb_protection = 1;            # activate rootshell bomb protection (an exploit discovered Oct 98)
      $stop_spam = 1;                  # activate anti-spam protection (continual posting of the same message)					
          $spam_time = 1;                  # if stop_spam is on, time limit on reposting (minutes)
      $cut_fields = 1;	               # activate length abuse protection
          $max_subject = 35;	             # 
          $max_name = 35;                  # If cut_fields is on, the length to cut
          $max_body = 25000;               # subject input to, etc.
          $max_url = 250;                  #
          $max_url_title = 250;            # Leave reasonable limits on all sections to stop
          $max_email = 100;                # people posting 10 MB messages, etc.
          $max_img = 250;                  #
 		   			
	

   ######################################
   # AutoCutting Variables (1=ON, 0=OFF)
   #

     $auto_cut = 1;                    # AutoCut the board when it gets to a certain size.
     $max_posts = 220;                 # Cut at this size. (ie, 100=small, 200=medium, 300=big)



   ###################################
   # Standard Variables (1=ON, 0=OFF)
   #

      $show_faq = 1;		         # Show a 'FAQ' link for every message (a bit useless)
      $quote_text = 1;	               # In replies, leave the previous message
      $subject_line = 0;	         # 0 = Quote Subject Editable; 1 = Quote Subject 
			                     #   UnEditable; 2 = Don't Quote Subject, Editable.
      $use_time = 1;		         # Put the time on every post (can be nice)
      $allow_html = 0;	               # Suggest leave this off for security reasons.
          $allow_blink_tag = 0;            #    
          $allow_javascript = 0;           # 
          $allow_meta = 0;                 # } If you put allow-html as 1, then
          $allow_ssi = 0;                  # } at least have these 3 set
          $allow_form = 0;                 # } as 0 for security reasons.					


#
# Nothing (necessary) to edit Past This Point
# A few things for advanced users only.
##############################################


###################################
# Main Script
#

# Get Form Information
&parse_form;

# Get the Data Number
&get_number;

# Put items into nice variables
&get_variables;

# If stop spam is turned on ($stop_spam = 0)
if($stop_spam == 1)
{
	&no_spam;
}

# Check Referring URL - remote post security fix
if($environment_lock == 1)
{
	&check_url;
}

# Get the check_ip subroutine
if($user_ban == 1)
{
      &check_ip;
}

# Check for CDA bad words
if ($topic_ban == 1) {
&topicban;
}

# Open the new file and write information to it.
&new_file;

# Open the Main WWWBoard File to add link
&main_page;

# Now Add Thread to Individual Pages
if ($num_followups >= 1) {
   &thread_pages;
}

# Return the user HTML
&return_html;

# Increment Number
&increment_num;


###############################
# Environment Lock Protection
#

sub check_url {

  ###############################
  # User Info Mod (Ken Williams)
  #

$ip = $ENV{'REMOTE_HOST'};
$n = `nslookup $ip | grep Name`; chop($n);
$host=substr($n, rindex($n, " ")+1);    
if ($host eq "") { $host=$ENV{'REMOTE_HOST'}; }
$nbr = $ENV{'REMOTE_ADDR'};
$bwr = $ENV{'HTTP_USER_AGENT'};                 # Advanced Users - choose...
$environ = "[$nbr] [$host] [$bwr]";           # Show all info about poster.
# $environ = "[$nbr]";                           # Only show IP of poster (default)


    #######################################
    # Webmaster Authentification Mod (webmaster@cyberarmy.com)
    #

    # if ($nbr eq "203.100.100.100") { $environ = "[User is Authenticated Webmaster]"};
                                                                # Above - Advanced Users...
                                                                # Put in your IP to set up
           									    # Webmaster Authentification

    local($check_referer) = 0;

    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
                $check_referer = 1;
                last;
            }
        }
    }
    else {
        $check_referer = 1;
    }
    if ($check_referer != 1) { &error('bad_referer') }
}


####################################
# Anti-Spam Mod (Epicurus)
#

sub no_spam
{

# set $nospammed to 0
$nospammed=0;
# set $ok to 1
$ok=1;
# set $user_ip to the IP of the person posting
$user_ip = $ENV{REMOTE_ADDR};
# if $spam_time is less than 10, add a 0 to the front of it
if($spam_time < 10) { $spam_time = "0"."$spam_time"; }
# set $new_day_time to 00$spam_time00 (if $spam_time = 3, it'd be 000300)
$new_day_time = "00$spam_time00";
# set $now to HOURMINUTESECONDS
$now = "$hour$min$sec";

# open the $no_spam_file file and read into @time_lines array
open(FILE,"$basedir/$no_spam_file") || &error("Unable to open $basedir/$no_spam_file!");
flock(FILE, 2);
@time_lines=<FILE>;
flock(FILE, 8);
close(FILE);
	# for every line in the $no_spam_file file
	foreach $time_line(@time_lines)
	{
		# chop at newline
		chop($time_line) if $time_line =~ /\n$/;
		# split into parts
		($addr,$dtime) = split(/\|\|/,$time_line);
		# split $dtime into time and day
		($dtime,$day) = split(/\:/,$dtime);
		# if $user_ip is the same as the IP in the file
		if($addr eq $user_ip)
		{
			# if $dtime (allowd post time) is greater than current $now
			if($dtime > $now)
			{
				# don't allow posting
				$ok=0;
			}
			# if today isn't the same as the day thier last post was made and $now is after $new_day_time
			if($day != $mday && $now > $new_day_time)
			{
				# allow posting
				$ok=1;
			}
		}
	}

# the current day
$allow_day = $mday;
# the current hour
$allow_hour = $hour;
# set time to the current minute + $spam_time
$allow_min = ($min+$spam_time);
# if $allow_min is greater than 59
if($allow_min > 59) 
{
	# subtract 59 from $allow_min
	$allow_min -= 59;
	# incriment $allow_hour
	$allow_hour++;
}
# if $allow_hour is greater than 23
if($allow_hour > 23)
{
	# subtract 23 from $allow_hour
	$allow_hour -= 23;
	# incriment $allow_day
	$allow_day++;
}
# set allow time to $allow_hour$allow_min$sec:$allow_day (11:30pm on 11/13/98 would be 113000:13)
$allow_time = "$allow_hour$allow_min$sec\:$allow_day";

# open $no_spam_file file and overwrite
open(FILE,">$basedir/$no_spam_file") || &error("Unable to open $basedir/$no_spam_file!");
flock(FILE, 2);
	# for every line in $no_spam_file
	foreach $time_line(@time_lines)
	{
		# chop at newline
		chop($time_line) if $time_line =~ /\n$/;
		# split into parts
		($addr,$dtime) = split(/\|\|/,$time_line);
		# split $dtime into time and day
		($dtime,$day) = split(/\:/,$dtime);
		# if time is less than now
		if($dtime <= $now)
		{
			# time is past
			$past=1;
		}
		# if time is not less than now
		else
		{
			# time is not past
			$past=0;
		}
		# if IP in file is the same as poster IP
		if($addr eq $user_ip)
		{
			# if allowed to post
			if($ok == 1)
			{
				# print IP and allow time to file
				print FILE "$user_ip||$allow_time\n";
			}
			# if not allowed to post
			else
			{
				# print the original line back to the file
				print FILE "$time_line\n";
			}
		# spam has been stopped
		$nospammed=1;
		}
		# if this isn't the IP of the poster
		else
		{
			# if allow time has not already passed
			if($past != 1)
			{
			# print original line to file
			print FILE "$time_line\n";
			# reset $past to 0
			$past=0;
			}
		}
	}
# if spam hasn't been stopped
if($nospammed == 0)
{
	# print IP and allowed post time to $no_spam_file
	print FILE "$user_ip||$allow_time\n";
}
# unlock and close $no_spam_file
flock(FILE, 8);
close(FILE);

	# if spam has been detected
	if($ok == 0)
	{
		# give the no spam error
        &error(no_spam);
	}
}



##########################################
# User Ban Mod (Ken Williams)
# Format: XXX.XXX.XXX.XXX, XXX.XXX., etc.
#

sub check_ip {
  if (-e "$basedir/$ip_file") {
      open(FILE,"$basedir/$ip_file") || die "Can't open ip file!\n";
         } else {
      open(FILE,">$basedir/$ip_file") || die "Can't open ip file!\n";
       print FILE "<!--Ban IP: -->";
      close(FILE);
     }
   @IPs = <FILE>;
  close(FILE);

  foreach $line (@IPs) {
    if ($line =~ m/<!--Ban IP: (.*)-->/) {
      next unless $line;
      @IPs = split(/,/, $1);

      foreach $ip (@IPs) {
        if ($ENV{'REMOTE_ADDR'}) {
          if ($ENV{'REMOTE_ADDR'} =~ /$ip/) {
            &error(ban_ip);
          }
        }
      }
    }
  }
}


#############################
# C.Y.R.Y.L Topic Ban Mod
# (DBasics.com, Cyberarmy)
#

sub topicban { 
  $badword_found = 0;   
   open(BADWORDS,"$basedir/$topicban_file") || die "FILE ERROR:$topicban_file\n";
   @badwords = <BADWORDS>;  
 close(BADWORDS);
   foreach $badword (@badwords) {

      # Strip any extra CR/LF's
      $badword =~ s/\n//g;
      $badword =~ s/\r//g;

      if (($body =~ /$badword/i) || ($subject =~ /$badword/i) || ($name =~ /$badword/i) || ($email =~ /$badword/i) || ($message_url_title =~ /$badword/i)) {
         $badword_found = 1;
         # If a bad word is found, highlight all occurances of it
         $body =~ s/($badword)/<B>$1<\/B>/ig;
         $subject =~ s/($badword)/<B>$1<\/B>/ig;
         $name =~ s/($badword)/<B>$1<\/B>/ig;
         $email =~ s/($badword)/<B>$1<\/B>/ig;
         $message_url_title =~ s/($badword)/<B>$1<\/B>/ig;      }   }
   
   if ($badword_found == 1) {      &error(bad_words);   }}


##############################
# Get Data Number Subroutine
#

sub get_number {
   open(NUMBER,"$basedir/$datafile");
    my($n) = <NUMBER>;
    $n =~ /(\d+)/;
    $num = $1;
   close(NUMBER);
   
   $cut = ($num - $max_posts); # autocut mod

   if ($num == 999999)  {
      $num = "1";
   }
   else {
      $num++;
   }
}


#########################
# Parse Form Subroutine
#

sub parse_form {

# read $buffer and $ENV{CONTENT_LENGTH} from STDIN (Standarad Input)
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
# if the buffer is shorter less than 5 chars
	if(length($buffer) < 5)
	{
		# the buffer is the query string
		$buffer = $ENV{QUERY_STRING}; 
	}


# split $buffer at the & symbols and put into @pairs array
@pairs = split(/&/, $buffer);

# for every element in the @pairs array
	foreach $pair (@pairs)
	{
	# split into parts
	($name, $value) = split(/=/, $pair);
	# change +'s to spaces
	$value =~ tr/+/ /;
	# UN-URL-encode input
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	# take out SSI/Comment tags
	$value =~ s/<!--(.|\n)*-->//g;
	# take out begin SSI/Comment tags
	$value =~ s/<!--(.|\n)*//g;
	# take out end SSI/Comment tags
	$value =~ s/(.|\n)*-->//g;
	# change pipes to their HTML-ASCII equivilent (&#124), because the datafile uses pipes
	$value =~ s/\|/\&#124/g;
	# while the value of this field has two spaces in a row
	while($value =~ /  /)
	{
		# change two spaces to one space
		$value =~ s/  / /g;
	}
	# if value of this field is nothing but a space, the value is null ("");
	if($value eq ' ') { $value = ""; }



      if ($allow_html != 1) {
         $value =~ s/<([^>]|\n)*>//g;
		# change < to &lt;
		$value =~ s/</&lt;/g;
		# change > to &gt;
		$value =~ s/>/&gt;/g;
      }
      else {
         unless ($name eq 'body') {
	    $value =~ s/<([^>]|\n)*>//g;
		# change < to &lt;
		$value =~ s/</&lt;/g;
		# change > to &gt;
		$value =~ s/>/&gt;/g;
         }
      }

#################################
# HTML Extra Parse (Ken Williams)
#

      if ($allow_blink_tag == 0) {
         $value =~ s@(<|&lt;?)\s?/?blink(>|&gt;?)@<font size=4 color=red> LAMER ATTEMPTED TO INSERT A BLINK TAG HERE <\/font>@gi;
      }  
      if ($allow_javascript == 0) {
         $value =~ s@(<|&lt;?)\s?/?script(>|&gt;?)@<font size=4 color=red> LAMER ATTEMPTED TO INSERT A JAVASCRIPTTAG HERE <\/font>@gi;
      }
      if ($allow_meta == 0) {
         $value =~ s@(<|&lt;?)\s?/?meta@<font size=4 color=red> LAMER ATTEMPTED TO INSERT A META TAG HERE <\/font>@gi;
      }
      if ($allow_ssi == 0) {
         $value =~ s@(<|&lt;?)\s?/?ssi@<font size=4 color=red> LAMER ATTEMPTED TO INSERT AN SSI TAG HERE <\/font>@gi;
      }
      if ($allow_form == 0) {
         $value =~ s@(<|&lt;?)\s?/?form@<font size=4 color=red> LAMER ATTEMPTED TO INSERT A FORM TAG HERE <\/font>@gi;
      }
      $FORM{$name} = $value;
   }

}

####################
# Get Variables
#

sub get_variables {


   if ($FORM{'followup'}) {
      $followup = "1";
       my($item);
       my(@list) = split(/,/,$FORM{'followup'});
       @followup_num = ();
       foreach $item (@list) {
         $item =~ /(\d+)/;
         push(@followup_num,$1);
         }
      $num_followups = @followups = @followup_num;
      $last_message = pop(@followups);
      $origdate = "$FORM{'origdate'}";
      $origname = "$FORM{'origname'}";
      $origsubject = "$FORM{'origsubject'}";


#################################
# WWWBoard Bomb Patch (Epicurus)
# 

if($bomb_protection == 1)
{
	$fn=0;
while($fn < $num_followups)
	{
		$cur_fup = @followups[$fn];
		$dfn=0;
		foreach $fm(@followups)
		{

			if(@followups[$dfn] == @followups[$fn] && $dfn != $fn)
			{
				&error(board_bomb);
			}
			$dfn++;
		}
	$fn++;	}
}
# End WWWBoard Bomb Patch
   }

   else {
      $followup = "0";
   }

   if ($FORM{'name'}) {
      $name = "$FORM{'name'}";
      $name =~ s/"//g;
      $name =~ s/</Jack Ass/g;
      $name =~ s/>/Jack Ass/g;
      $name =~ s/\&/Jack Ass/g;
      $name =~ s/<([^>]|\n)*>/Jack Ass/g;
   }
   else {
      &error(no_name);
   }

   if ($FORM{'email'} =~ /.*\@.*\..*/) {
      $email = "$FORM{'email'}";
   }


   if ($FORM{'subject'}) {
      $subject = "$FORM{'subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;
   }
   else {
      &error(no_subject);
   }

   if ($FORM{'url'} =~ /.*\:.*\..*/ && $FORM{'url_title'}) {
      $message_url = "$FORM{'url'}";
      $message_url_title = "$FORM{'url_title'}";
}

   if ($FORM{'img'} =~ /.*tp:\/\/.*\..*/) {
      $message_img = "$FORM{'img'}";
   }

   if ($FORM{'body'}) {
      $body = "$FORM{'body'}";
      $body =~ s/\cM//g;
      $body =~ s/\n\n/<p>/g;
      $body =~ s/\n/<br>/g;
      $body =~ s/&lt;/</g; 
      $body =~ s/&gt;/>/g; 
      $body =~ s/&quot;/"/g;

   }
   else {
      &error(no_body);
   }



###############################
# Length Abuse Mod (Epicurus,
# webmaster@cyberarmy.com)
#

if($cut_fields == 1)
{

	if(length($name) > $max_name)
	{
			$name = substr($name, 0, $max_name);
	}
	if(length($body) > $max_body)
	{
			$body = substr($body, 0, $max_body);
	}
	if(length($url) > $max_url)
	{
			$url = substr($url, 0, $max_url);
	}
      if(length($url_title) > $max_url_title)
	{
			$url_title = substr($url_title, 0, $max_url_title);
	}
      if(length($email) > $max_email)
	{
			$email = substr($email, 0, $max_email);
	}
	if(length($img) > $max_img)
	{
			$img = substr($img, 0, $max_img);
	}
	if(length($subject) > $max_subject)
	{
		if($followup == 1)
		{
			$subject = substr($subject, 0, ($max_subject+4));
		}
		else
		{
			$subject = substr($subject, 0, $max_subject);
		}
	}
} #


   if ($quote_text == 1) {
      $hidden_body = "$body";
      $hidden_body =~ s/</&lt;/g;
      $hidden_body =~ s/>/&gt;/g;
      $hidden_body =~ s/"/&quot;/g;
   }


   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$mon++;
if($mday < 10) { $mday = "0"."$mday"; }
if($mon < 10) { $mon = "0"."$mon"; }
if($hour < 10) { $hour = "0"."$hour"; }
if($min < 10) { $min = "0"."$min"; }
if($sec < 10) { $sec = "0"."$sec"; }

# time = HOUR:MINUTE:SECONDS MONTH/DAY/YEAR
$time = "$hour\:$min\:$sec $mon/$mday/$year";

   @months = ("January","February","March","April","May","June","July","August","September","October","November","December");

   if ($use_time == 1) {
      $date = "$hour\:$min\:$sec $mon/$mday/$year";
   }
   else {
      $date = "$month/$mday/$year";
   }
   chop($date) if ($date =~ /\n$/);

   $long_date = "$months[$mon] $mday, 19$year at $hour\:$min\:$sec";
}      


#######################
# New File Subroutine
#

sub new_file {

   open(NEWFILE,">$basedir/$mesgdir/$num\.$ext") || die $!;
   print NEWFILE "<html>\n";
   print NEWFILE "  <head>\n";
   print NEWFILE "    <title>$subject</title>\n";
   print NEWFILE "  </head>\n";
   print NEWFILE "  $page_top\n";
   print NEWFILE "    <center>\n";
   print NEWFILE "      <h1>$subject</h1>\n";
   print NEWFILE "    </center>\n";
   print NEWFILE "<hr size=7 width=75%>\n";
   if ($show_faq == 1) {
      print NEWFILE "<center>[<a href=\"#followups\">Follow Ups</a>] [<a href=\"#postfp\">Post Followup</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>] [<a href=\"$baseurl/$faqfile\">FAQ</a>]</center>\n";
   }
   else {
      print NEWFILE "<center>[<a href=\"#followups\">Follow Ups</a>] [<a href=\"#postfp\">Post Followup</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>]</center>\n";
   }
   print NEWFILE "<hr size=7 width=75%><p>\n";

   print NEWFILE "Posted by ";

   if ($email) {
      print NEWFILE "<a href=\"mailto:$email\">$name</a> $environ on $long_date:<p>\n";
   }
   else {
      print NEWFILE "$name $environ on $long_date:<p>\n";
   }

   if ($followup == 1) {
      print NEWFILE "In Reply to: <a href=\"$last_message\.$ext\">$origsubject</a> posted by ";

      if ($origemail) {
         print NEWFILE "<a href=\"$origemail\">$origname</a> on $origdate:<p>\n";
      }
      else {
         print NEWFILE "$origname on $origdate:<p>\n";
      }
   }

   if ($message_img) {
      print NEWFILE "<center><img src=\"$message_img\"></center><p>\n";
   }
   print NEWFILE "$body\n";
   print NEWFILE "<br>\n";
   if ($message_url) {
      print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
   }
   print NEWFILE "<br><hr size=7 width=75%><p>\n";
   print NEWFILE "<a name=\"followups\">Follow Ups:</a><br>\n";
   print NEWFILE "<ul><!--insert: $num-->\n";
   print NEWFILE "</ul><!--end: $num-->\n";
   print NEWFILE "<br><hr size=7 width=75%><p>\n";
   print NEWFILE "<a name=\"postfp\">Post a Followup</a><p>\n";
   print NEWFILE "<form method=POST action=\"$cgi_url\">\n";
   print NEWFILE "<input type=hidden name=\"followup\" value=\"";
   if ($followup == 1) {
      foreach $followup_num (@followup_num) {
         print NEWFILE "$followup_num,";
      }
   }
   print NEWFILE "$num\">\n";
   print NEWFILE "<input type=hidden name=\"origname\" value=\"$name $environ\">\n";
   if ($email) {
      print NEWFILE "<input type=hidden name=\"origemail\" value=\"$email\">\n";
   }
   print NEWFILE "<input type=hidden name=\"origsubject\" value=\"$subject\">\n";
   print NEWFILE "<input type=hidden name=\"origdate\" value=\"$long_date\">\n";
   print NEWFILE "Name: <input type=text name=\"name\" size=50><br>\n";
   print NEWFILE "E-Mail: <input type=text name=\"email\" size=50><p>\n";
   if ($subject_line == 1) {
      if ($subject_line =~ /^Re:/) {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"$subject\">\n";
         print NEWFILE "Subject: <b>$subject</b><p>\n";
      }
      else {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"Re: $subject\">\n";
         print NEWFILE "Subject: <b>Re: $subject</b><p>\n";
      }
   } 
   elsif ($subject_line == 2) {
      print NEWFILE "Subject: <input type=text name=\"subject\" size=50><p>\n";
   }
   else {
      if ($subject =~ /^Re:/) {
         print NEWFILE "Subject: <input type=text name=\"subject\"value=\"$subject\" size=50><p>\n";
      }
      else {
         print NEWFILE "Subject: <input type=text name=\"subject\" value=\"Re: $subject\" size=50><p>\n";
      }
   }
   print NEWFILE "Comments:<br>\n";
   print NEWFILE "<textarea name=\"body\" COLS=50 ROWS=10>\n";
   if ($quote_text == 1) {
      @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
      foreach $chunk_of_body (@chunks_of_body) {
         @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
         foreach $line_of_body (@lines_of_body) {
            print NEWFILE ": $line_of_body\n";
         }
         print NEWFILE "\n";
      }
   }
   print NEWFILE "</textarea>\n";
   print NEWFILE "<p>\n";
   print NEWFILE "Optional Link URL: <input type=text name=\"url\" size=50><br>\n";
   print NEWFILE "Link Title: <input type=text name=\"url_title\" size=48><br>\n";
   print NEWFILE "Optional Image URL: <input type=text name=\"img\" size=49><p>\n";
   print NEWFILE "<input type=submit value=\"Submit Follow Up\"> <input type=reset>\n";

  
   print NEWFILE "$page_bottom\n";
   close(NEWFILE);
}


###############################
# Main WWWBoard Page Subroutine
#

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || die $!;
   @main = <MAIN>;
   close(MAIN);


   open(MAIN,">$basedir/$mesgfile") || die $!;
   if ($followup == 0) {
      foreach $main_line (@main) {
         if ($main_line =~ /<!--begin-->/) {
            print MAIN "<!--begin-->\n";
	    print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   else {
      foreach $main_line (@main) {
	 $work = 0;
         if ($main_line =~ /<ul><!--insert: $last_message-->/) {
            print MAIN "<ul><!--insert: $last_message-->\n";
            print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		  $work = 1;
               }
            }
            if ($work != 1) {
               print MAIN "$main_line";
            }
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   close(MAIN);


#################################
# Autocut Mod (www.cyberarmy.com)
#

if($auto_cut == 1)
  {
   open(MSGS,"$basedir/$mesgfile") || die $!;
   @lines = <MSGS>;
   close(MSGS);

      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--top: $cut-->/) {
            splice(@lines, $j, 3);
            $j -= 3;
         }
         elsif ($lines[$j] =~ /<!--end: $cut-->/) {
            splice(@lines, $j, 1);
            $j--;
         }
      }
      $filename = "$basedir/$mesgdir/$cut\.$ext";
      if (-e $filename) {
         unlink("$filename") || push(@NOT_REMOVED,$cut);
      }

   open(WWWBOARD,">$basedir/$mesgfile");
   print WWWBOARD @lines;
   close(WWWBOARD);  
  }    
}


############################################
# Add Followup Threading to Individual Pages
#

sub thread_pages {

   foreach $followup_num (@followup_num) {
      open(FOLLOWUP,"$basedir/$mesgdir/$followup_num\.$ext");
      @followup_lines = <FOLLOWUP>;
      close(FOLLOWUP);

      open(FOLLOWUP,">$basedir/$mesgdir/$followup_num\.$ext");
      foreach $followup_line (@followup_lines) {
         $work = 0;
         if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
	    print FOLLOWUP "<ul><!--insert: $last_message-->\n";
            print FOLLOWUP "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> <b>$name</b> <i>$date</i>\n";
            print FOLLOWUP "(<!--responses: $num-->0)\n";
            print FOLLOWUP "<ul><!--insert: $num-->\n";
            print FOLLOWUP "</ul><!--end: $num-->\n";
         }
         elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
                  $work = 1;
               }
            }
            if ($work != 1) {
               print FOLLOWUP "$followup_line";
            }
         }
         else {
            print FOLLOWUP "$followup_line";
         }
      }
      close(FOLLOWUP);
   }
}

sub return_html {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Message Added: $subject</title></head>\n";
   print "$page_top<center><h1>Message Added: $subject</h1></center>\n";
   print "The following information was added to the message board:<p><hr size=7 width=75%><p>\n";
   print "<b>Name:</b> $name<br>\n";
   print "<b>E-Mail:</b> $email<br>\n";
   print "<b>Subject:</b> $subject<br>\n";
   print "<b>Body of Message:</b><p>\n";
   print "$body<p>\n";
   if ($message_url) {
      print "<b>Link:</b> <a href=\"$message_url\">$message_url_title</a><br>\n";
   }
   if ($message_img) {
      print "<b>Image:</b> <img src=\"$message_img\"><br>\n";
   }
   print "<b>Added on Date:</b> $date<p>\n";
   print "<hr size=7 width=75%>\n";
   print "<center>[<a href=\"$baseurl/$mesgdir/$num\.$ext\">Go to Your Message</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>]</center>\n";
   print "</body></html>\n";
}

sub increment_num {
   open(NUM,">$basedir/$datafile") || die $!;
   print NUM "$num";
   close(NUM);
}


############################
# Error Messages Subroutine
#

sub error {
   $error = $_[0];

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name') {
      print "<html><head><title>$title ERROR: No Name</title></head>\n";
      print "$page_top<center><h1>ERROR: No Name</h1></center>\n";
      print "You forgot to fill in the 'Name' field in your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subject and Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   } 
   elsif ($error eq 'no_subject') {
      print "<html><head><title>$title ERROR: No Subject</title></head>\n";
      print "$page_top<center><h1>ERROR: No Subject</h1></center>\n";
      print "You forgot to fill in the 'Subject' field in your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subject and Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_body') {
      print "<html><head><title>$title ERROR: No Message</title></head>\n";
      print "$page_top<center><h1>ERROR: No Message</h1></center>\n";
      print "You forgot to fill in the 'Message' fieldin your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subjectand Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }

   elsif ($error eq 'ban_ip') {
      print "<html><head><title>$title ERROR: You Have Been Denied Access</title></head>\n";
      print "$page_top<center><h1>ERROR: ACCESS DENIED!<br><br>Hey Lamer!  You've been BANNED!<br><br><br>\n";
      print "<p><b>If you believe you have been unjustly banned and want the ban removed, then send email to the webmaster and we will consider your plea.</b>\n";
      print "</body></html>\n";
      exit;
   }

   elsif ($error eq 'bad_words') {
      print "<html><head><title>$title Lameness Protection Initiated</title></head>\n";
      print "$page_top<center><h1>ERROR: Lameness Warning!</h1></center>\n";
      print "<br>Our AI web board script (C.Y.R.Y.L) has read your post and has determined that it may contain banned topics. Basically, you are not permitted to post on topics including questions asking to 'how to hack', 'hacking hotmail', geocities, xoom, tripod web pages, etc. A ban has also been placed on discussion of remote control 'trojans' such as Back Orifice, NetBus, etc. Some heavy flaming and swearing has also been banned. Why? The purpose of this board is for serious computing and security discussion. Left unmoderated, we have found that the board gets filled with posts from people asking 'how to hack' and how to nuke and 'take control' of peoples computers. Then, these questions result in the poster being flamed. So, we basically want to keep the quality of the board up while we save you from being flamed! If this warning has been triggered by accident, please remove the offending words / comments / concepts from your post and re-send. Otherwise, post your message on <a href =\"http://www.cyberarmy.com/search/Discussion_Forums/Web_Boards/\">someone elses board</a>:\n";
      print "<P>Remove the following language / words / or concepts and repost:<br><BR><hr size=7 width=75%><P>\n";
      print "FROM: $name<BR>\n";      print "EMAIL: $email<BR>\n";
      print "URL TITLE: $message_url_title<BR>\n";
      print "SUBJECT: $subject<P>\n";
      print "BODY OF MESSAGE: $body<P><P>\n";
      print "<hr size=7 width=75%>\n";
      print "</body></html>\n";
      exit;
   }

   elsif ($error eq 'board_bomb') {
      print "<html><head><title>$title Bombing Protection Initiated</title></head>\n";
      print "$page_top<center><h1>ERROR: Bombing Protection Initiated</h1></center>\n";
      print "<p><b>Bombing the board, lamer? You have been LOGGED $environ, and we will contact your ISP.</b></body></html>\n";
      exit;
   }

   elsif ($error eq 'no_spam') {
      print "<html><head><title>$title Spamming Protection Initiated</title></head>\n";
      print "$page_top<center><h1>ERROR: $spam_time Minute Post Rule</h1></center>\n";
      print "<p><b>To prevent spam a $spam_time minute posting rule has been implemented.  You cannot post more than one message in any $spam_time minute interval.  Please try to post your message again.</b>\n";
      print "<p>If you feel you have reached this page in error please try to post your message again in $spam_time minutes.</body></HTML>\n";
      exit;
   }
   
   elsif ($error eq 'bad_referer') {
        print "<HTML><HEAD><TITLE>Security Lockout</TITLE></HEAD><body bgcolor=\"#000000\" text=\"#008080\" link=\"#00FF00\" vlink=\"#008080\" alink=\"#00FF00\">\n";

print "<p>&nbsp;</p><font face=\"arial\">\n";

print "<center><font color=00ff00><H2>Security Lockout</H2></center><br>\n";
        print "<p>This script can only be called from $baseurl, to help prevent people exploiting it. For some reason, the script has determined that it was not called from $baseurl. Occassionaly, it is mistaken. If you are not trying to hack us, you should retype $baseurl in your browser, reload the page, and try again. If that still doesnt work, contact the webmaster. This error and your details have been logged.</p>\n";
        print "</BODY></HTML>";

      exit;
   } 

   else {
      print "ERROR!  Undefined.\n";
   }
  exit;
}

###############################
# Bottom of the Form
#

sub rest_of_form {

   print "<form method=POST action=\"$cgi_url\">\n";

   if ($followup == 1) {
      print "<input type=hidden name=\"origsubject\" value=\"$FORM{'origsubject'}\">\n";
      print "<input type=hidden name=\"origname\" value=\"$FORM{'origname'}\">\n";
      print "<input type=hidden name=\"origemail\" value=\"$FORM{'origemail'}\">\n";
      print "<input type=hidden name=\"origdate\" value=\"$FORM{'origdate'}\">\n";
      print "<input type=hidden name=\"followup\" value=\"$FORM{'followup'}\">\n";
   }
   print "Name: <input type=text name=\"name\" value=\"$FORM{'name'}\" size=50><br>\n";
   print "E-Mail: <input type=text name=\"email\" value=\"$FORM{'email'}\" size=50><p>\n";
   if ($subject_line == 1) {
      print "<input type=hidden name=\"subject\" value=\"$FORM{'subject'}\">\n";
      print "Subject: <b>$FORM{'subject'}</b><p>\n";
   } 
   else {
      print "Subject: <input type=text name=\"subject\" value=\"$FORM{'subject'}\" size=50><p>\n";
   }
   print "Message:<br>\n";
   print "<textarea COLS=50 ROWS=10 name=\"body\">\n";
   $FORM{'body'} =~ s/</&lt;/g;
   $FORM{'body'} =~ s/>/&gt;/g;
   $FORM{'body'} =~ s/"/&quot;/g;
   print "$FORM{'body'}\n";
   print "</textarea><p>\n";
   print "Optional Link URL: <input type=text name=\"url\" value=\"$FORM{'url'}\" size=45><br>\n";
   print "Link Title: <input type=text name=\"url_title\" value=\"$FORM{'url_title'}\" size=50><br>\n";
   print "Optional Image URL: <input type=text name=\"img\" value=\"$FORM{'img'}\" size=45><p>\n";
   print "<input type=submit value=\"Post Message\"> <input type=reset>\n";
   print "</form>\n";
   print "<br><hr size=7 width=75%>\n";
   if ($show_faq == 1) {
      print "<center>[<a href=\"#followups\">Follow Ups</a>] [<a href=\"#postfp\">Post Followup</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>] [<a href=\"$baseurl/$faqfile\">FAQ</a>]</center>\n";
   }
   else {
      print "<center>[<a href=\"#followups\">Follow Ups</a>] [<a href=\"#postfp\">Post Followup</a>] [<a href=\"$baseurl/$mesgfile\">$title</a>]</center>\n";
   }
   print "</body></html>\n";
}
